import { Attribute } from './attribute';
import { Expression } from './expression';
import { Field } from './field';
import { Method } from './method';
import { TypeContainer } from './type-container';
import { Property } from './property';
import { Type } from './type';
export declare function sortByNamePartialFirst(a: Method, b: Method): number;
export declare class Class extends Type {
    parent?: Class | undefined;
    protected classOrStruct: 'class' | 'struct';
    isStatic: boolean;
    protected fields: Field[];
    constructor(namespace: TypeContainer, name: string, parent?: Class | undefined, objectIntializer?: Partial<Class>);
    hasMethodWithSameDeclaration(method: Method): boolean;
    get headerComment(): string;
    get signature(): string;
    get definition(): string;
    add<T extends object>(item: T & (Method | Property | Attribute | Field)): T;
    addField(field: Field): Field;
    get declaration(): string;
    new(...parameters: Array<Expression>): Expression;
    property(name: string): Property;
    $<T extends (Property | Method | Field)>(name: string): T;
}
//# sourceMappingURL=class.d.ts.map