"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
const codegen_1 = require("@azure-tools/codegen");
const statement_1 = require("./statement");
class CatchStatement extends statement_1.Statements {
    constructor(parameter, body, objectInitializer) {
        super(body);
        this.parameter = parameter;
        this.apply(objectInitializer);
    }
    get implementation() {
        const when = this.when ? ` when (${this.when})` : '';
        const p = this.parameter ? ` (${this.parameter.declaration})` : '';
        return `
catch${p}${when}
{
${codegen_1.indent(super.implementation)}
}`.trim();
    }
}
exports.CatchStatement = CatchStatement;
function Catch(parameter, body, objectInitializer) {
    return new CatchStatement(parameter, body, objectInitializer);
}
exports.Catch = Catch;
//# sourceMappingURL=catch.js.map